#convert stage series for import in BaratinAGE 2.1

stage_file_dir="hdata/corr/"

slope=1   #for Baratin-output only: potentially convert slant stage to perpendicular stage
intercept=0


# gauge="Lascuarre"
# device="TT"
# datum="tube"
# slope=0.104187146   #convert slant stage to perpendicular stage (from gauge-logbook, meta)
# intercept=-0.019260209
# 
# gauge="Cabecera"
# device="TT"
# datum="weir"

# gauge="Carrasquero"
# device="TT"
# datum="bridge"

# gauge="Ceguera"
# device="TT"
# datum="bridge"




gauge="Villacarli"
device="RQ24"
datum="downstream-left"
# #   
# 






do_h0_correction = TRUE

source("f_read_loggerdata.R") 

logger_data=na.omit(read_loggerdata(gauge, datum, device, stage_file_dir=stage_file_dir, do_correct_tz = FALSE)) #try to read logger data
if (is.null(logger_data)) stop("corrected file not found for current gauge and datum")

if (do_h0_correction)
{
  load(file=paste(stage_file_dir,gauge,"_",device,"_",datum,"_loflophases.RData",sep=""))
  lo_flo =lo_flo_fun(logger_data$date) #h0 stage from interpolation of manually detected phases
} else
lo_flo = rep(0, nrow(logger_data))
  

# write file for import to CUAHSI
  source("f_write4cuahsi.R")
  names(logger_data)[names(logger_data)=="stage"] = "DataValue" #rename column of actual data value
  if (median(logger_data$DataValue, na.rm=TRUE) > 100)
    logger_data$DataValue = logger_data$DataValue / 1000 #convert mm to m
  logger_data$OffsetValue = lo_flo
  
  write4cuahsi(cdata = logger_data, dest_file = paste0(stage_file_dir, "../../CuahsiData/", gauge,"_",device,"_",datum, "_corr_h.txt"), 
               sitecode = gauge, varcode = "water_stage", methodc = device, sourcec = "SESAMII_hydro")
      
  
# write stage file for Baratin
  bfile = paste0(stage_file_dir, "4baratin/", gauge,"_",device,"_",datum, "_corr.txt")
  write.table(file=bfile, "year;month;day;hour;min;sec;h;uh;bHindx;bH", quote=FALSE, row.names=FALSE, col.names=FALSE, append = FALSE)
  
  write.table(file=bfile, 
              data.frame(date=format(logger_data$date, "%Y;%m;%d;%H;%M;%S", tz="etc/GMT-1"),
                         h=(logger_data$DataValue-logger_data$OffsetValue)*slope+intercept, uh=0.01, bhi=0, bh=0), sep=";", quote=FALSE, row.names=FALSE, append = TRUE, col.names=FALSE) #write stage data
  
  windows()
  plot((logger_data$DataValue-logger_data$OffsetValue)*slope+intercept, type="l")
  