#write data in as ASCII file for CUAHSI-import

write4cuahsi <- function(cdata, dest_file, sitecode, varcode,  methodc=NULL, sourcec, censorc="nc", OffsetValue="", qualityc=1, ValueAccuracy="", maxrec=500000)
{
  n = nrow(cdata)
  #browser()
  dtutc<- format(cdata$date, tz="UTC")
  dtloc<- format(cdata$date, tz="Etc/GMT-1") # LocalDateTime winter time GMT+1
  utc_offset = as.numeric(format(cdata$date, format = "%z"))/100
  
  #add necessary fields, if not already contained in dataframe
  if (is.null(cdata$sitecode)) cdata$sitecode=sitecode
  if (is.null(cdata$varcode))  cdata$varcode=varcode
  if (is.null(cdata$censorc))  cdata$censorc=censorc
  if (is.null(cdata$methodc))  cdata$methodc=methodc
  if (is.null(cdata$sourcec))  cdata$sourcec=sourcec
  if (is.null(cdata$qualityc)) cdata$qualityc=qualityc
  if (is.null(cdata$ValueAccuracy)) cdata$ValueAccuracy=ValueAccuracy
  if (is.null(cdata$OffsetValue))   cdata$OffsetValue=OffsetValue
  

  output_table=data.frame(DataValue=round(cdata$DataValue, digits = 3),
                          ValueAccuracy=cdata$ValueAccuracy,
                          LocalDateTime=dtloc,
                          UTCOffset=utc_offset,
                          DateTimeUTC=dtutc,
                          SiteCode=cdata$sitecode,
                          VariableCode=cdata$varcode,
                          OffsetValue=cdata$OffsetValue,
                          OffsetTypeCode="",
                          CensorCode = cdata$censorc,
                          QualifierCode="",
                          MethodCode = cdata$methodc,
                          SourceCode = cdata$sourcec,
                          SampleCode="",
                          DerivedFromID="",
                          QualityControlLevelCode= cdata$qualityc )
  
  #maxrec <- 500000 # max number rows upload to CUASHI server is 750.000, but somehow not possible to upload; error message 'Bad Gateway'
  k <- ceiling(n/maxrec) # number of necessary output tables (minus one)
  
  
  for(i in 1:k)
      write.table(file=paste0(dest_file,i), x = output_table[((i-1)*maxrec+1) : min(i*maxrec, n),], na = "-9999", sep=",", row.names = FALSE, quote = FALSE)
  
  
}